<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00006000ElementoService;
use SM\Traits\TResponse;

class Sm00006000ElementoController
{
    use TResponse;

    protected $ElementoService;

    public function __construct(Sm00006000ElementoService $ElementoService)
    {
        $this->ElementoService = $ElementoService;
    }

    public function getElementos(Request $request)
    {
        try {
            $data = $this->ElementoService->getElementos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTipoMedidaVariavel()
    {
        try {
            $data = $this->ElementoService->getTipoMedidaVariavel();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRelacionamentoServico()
    {
        try {
            $data = $this->ElementoService->getRelacionamentoServico();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCentroCusto()
    {
        try {
            $data = $this->ElementoService->getCentroCusto();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function frameRelacionamentoServico(Request $request)
    {
        try {
            $data = $this->ElementoService->frameRelacionamentoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarElementoAdd(Request $request)
    {
        try {
            $data = $this->ElementoService->salvarElementoAdd($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarElementoEdit(Request $request)
    {
        try {
            $data = $this->ElementoService->salvarElementoEdit($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirElementos(Request $request)
    {
        try {
            $data = $this->ElementoService->excluirElementos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTipoMedida()
    {
        try {
            $data = $this->ElementoService->getTipoMedida();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarRelacionamentoServicoEdit(Request $request)
    {
        try {
            $data = $this->ElementoService->salvarRelacionamentoServicoEdit($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarRelacionamentoServicoAdd(Request $request)
    {
        try {
            $data = $this->ElementoService->salvarRelacionamentoServicoAdd($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarRelacionamentoServico(Request $request)
    {
        try {
            $data = $this->ElementoService->deletarRelacionamentoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarCadastramentoAutomatico(Request $request)
    {
        try {
            $data = $this->ElementoService->salvarCadastramentoAutomatico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}